<!DOCTYPE html>
<html>
    <head>
        <title>Lab 2</title>
        <link rel="stylesheet" href="styles/site.css" type="text/css" />
        <META http-equiv="Content-Type" content="text/html; charset=UTF-8">
    </head>

    <body class="theme-default aui-theme-default">
        <div id="page">
            <div id="main" class="aui-page-panel">
                <div id="main-header">
                </div>

                <div id="content" class="view">
                    
                    <div id="main-content" class="wiki-content group">
                    <h2 id="AWSLab2-Lab2:TrainandEventNotifications">Lab 2: Train and Event Notifications</h2><p>Overview:</p><p>This lab is composed of two parts:</p><ul><li><p>Setting up event notifications</p></li><li><p>Training the model.</p></li></ul><p>Setting up event notifications will enable you to receive emails about the status of your pipeline. You will do this using both Amazon SNS and Amazon EventBridge. In Amazon SNS you will create a subscription to a topic that you create. The topic will contain any SageMaker training job changes.</p><p>In EventBridge you will create a rule defining when to send an email. EventBridge will detect any change in the state of a training job which will trigger an email from Amazon SNS.</p><p>You will notice an added training step to pipeline.py. Amazon’s built-in algorithm XGBoost is used to train the model on the wine data. You will run the pipeline again and view the updated pipeline graph in SageMaker Studio. You will also receive an email about the status of the training job.</p><p><em>Roadmap:</em></p><p><em>Part 1:</em></p><ol><li><p>Open the Lab environment and log in to AWS</p></li><li><p>Navigate to Amazon SNS</p></li><li><p>Create a topic</p></li><li><p>Create an email subscription to the topic</p></li><li><p>Confirm email subscription</p></li><li><p>Create a rule in EventBridge</p></li></ol><p><em>Part 2:</em></p><ol><li><p>Return to your SageMaker Notebook Instance</p></li><li><p>Set up your repository for Lab 2</p></li><li><p>Read through the Training step in pipeline.py</p></li><li><p>Run the pipeline</p></li><li><p>View Pipeline Graph</p></li><li><p>Check your email</p></li></ol><p><em>Instructions:</em></p><ol><li><p>Open the Lab environment and log in to AWS</p><ol><li><p>Use the provided link to open CloudShare. Click <strong>Microsoft Office Professional Plus 2019 (Windows Server 2019) </strong>at the top of the page. The VM will load and open.</p></li><li><p>Once in the VM open Google Chrome from the taskbar and navigate to <a class="external-link" href="https://aws.amazon.com/" rel="nofollow">https://aws.amazon.com/</a></p></li><li><p>Sign in to the Console using the AWS credentials located under <strong>Public Clouds </strong>on the left sidebar.</p></li></ol></li><li><p>Navigate to <strong>Simple Notification Service (SNS)</strong> using the search bar</p></li><li><p>Create a topic</p><ol><li><p>Navigate to <strong>Topics</strong> on the left navigation bar. Click :console: if the console is hidden.</p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324135956.png" data-image-src="attachments/2324561934/2324135956.png" data-height="511" data-width="1718" data-unresolved-comment-count="0" data-linked-resource-id="2324135956" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-013014.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="24b2d93f-1b31-4a8f-82ca-f0f2499f0d37" data-media-type="file"></span></li><li><p>Click <strong>Create Topic</strong>. You may notice an <strong>AccessDeniedException </strong>error, but you can ignore it and continue.</p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324135962.png" data-image-src="attachments/2324561934/2324135962.png" data-height="198" data-width="1629" data-unresolved-comment-count="0" data-linked-resource-id="2324135962" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220411-140442.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="b7f31fcc-e6ce-42bf-b896-1a92fc097d93" data-media-type="file"></span></li><li><p>Select <strong>Standard</strong> type</p></li><li><p>Enter a name for the topic. This can be as simple as SageMakerTrainingJob.</p></li><li><p>Leave everything else default.</p></li><li><p>Click <strong>Create Topic</strong>.</p></li></ol></li><li><p>Create an email subscription to a topic</p><ol><li><p>Click <strong>Create Subscription</strong>.</p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324135968.png" data-image-src="attachments/2324561934/2324135968.png" data-height="654" data-width="1707" data-unresolved-comment-count="0" data-linked-resource-id="2324135968" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-013226.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="22c54328-6669-4604-8825-21c6ed471d34" data-media-type="file"></span></li><li><p>Your topic should be automatically loaded in the Topic ARN box</p><ol><li><p>If not, select your topic ARN from the dropdown menu. This will start with <strong>arn:aws:</strong> and contain your topic name.</p></li></ol></li><li><p>Under protocol select <strong>email</strong>.</p></li><li><p>Enter your email.</p></li><li><p>Click <strong>Create Subscription</strong>.</p></li></ol></li><li><p>Confirm your subscription</p><ol><li><p>A subscription confirmation will be sent to your email.</p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324135974.png" data-image-src="attachments/2324561934/2324135974.png" data-height="171" data-width="684" data-unresolved-comment-count="0" data-linked-resource-id="2324135974" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-013512.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="b333cc5f-190b-4cf6-9005-fe97a3a304e2" data-media-type="file"></span></li><li><p>Open the email. If prompted, click <strong>Confirm Subscription</strong>.</p></li></ol></li><li><p>Create Completed Rule EventBridge</p><ol><li><p>In the AWS search bar at the top, Navigate to <strong>Amazon EventBridge</strong>.</p></li><li><p>Click <strong>Create Rule</strong></p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324135980.png" data-image-src="attachments/2324561934/2324135980.png" data-height="584" data-width="1703" data-unresolved-comment-count="0" data-linked-resource-id="2324135980" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-013945.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="830c91a2-1321-40f0-ad3c-5eb2959f8eaf" data-media-type="file"></span></li><li><p>Name the rule <strong>SageMakerCompleted</strong> and add a description</p></li><li><p>Ensure that the Event bus option selected is <em>default</em></p></li><li><p>Toggle “Enable the rule on the selected event bus option” to ON</p></li><li><p>Select <strong>Rule with an event pattern</strong>. Click <strong>Next</strong>.</p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324135986.png" data-image-src="attachments/2324561934/2324135986.png" data-height="667" data-width="1713" data-unresolved-comment-count="0" data-linked-resource-id="2324135986" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-014235.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="bc52a73c-3996-4d12-a76c-6367d1a62b2a" data-media-type="file"></span></li><li><p>In the Event Source section, select <strong>AWS events or EventBridge partner events</strong>,</p></li><li><p>Scroll down to the Event Pattern section and select the <strong>Custom patters (JSON editor)</strong> tab</p></li><li><p>Paste the following code into the editor and click Next.</p><ol><li><div class="code panel pdl" style="border-width: 1px;"><div class="codeContent panelContent pdl">
<pre class="syntaxhighlighter-pre" data-syntaxhighlighter-params="brush: java; gutter: false; theme: Confluence" data-theme="Confluence">{
  &quot;source&quot;: [&quot;aws.sagemaker&quot;],
  &quot;detail-type&quot;: [&quot;SageMaker Processing Job State Change&quot;],
  &quot;detail&quot;: {
    &quot;ProcessingJobStatus&quot;: [&quot;Completed&quot;]
  }
}
</pre>
</div></div></li></ol></li><li><p>Keep the Target type as <strong>AWS service</strong>.</p></li><li><p>When selecting a target from the dropdown, choose <strong>SNS topic </strong>as the target.</p></li><li><p>From the Topic dropdown, select the topic you created</p></li><li><p>Select the <strong>Additional Settings</strong> drop-down and select <strong>Input transformer</strong> under Configure target input</p></li><li><p>Click <strong>Configure Input Transformer</strong></p><ol><li><p>Scroll down to Target input transformer and paste the following code under <strong>Input path</strong></p><ol><li><div class="code panel pdl" style="border-width: 1px;"><div class="codeContent panelContent pdl">
<pre class="syntaxhighlighter-pre" data-syntaxhighlighter-params="brush: java; gutter: false; theme: Confluence" data-theme="Confluence">{
  &quot;Arn&quot;:&quot;$.detail.TrainingJobArn&quot;,
  &quot;CreationTime&quot;:&quot;$.detail.CreationTime&quot;,
  &quot;FailureReason&quot;:&quot;$.detail.FailureReason&quot;,
  &quot;Name&quot;:&quot;$.detail.TrainingJobName&quot;,
  &quot;Status&quot;:&quot;$.detail.TrainingJobStatus&quot;,
  &quot;TrainingEndTime&quot;:&quot;$.detail.TrainingEndTime&quot;,
  &quot;TrainingStartTime&quot;:&quot;$.detail.TrainingStartTime&quot;
}</pre>
</div></div></li></ol></li><li><p>Paste the following code under <strong>Template</strong></p><ol><li><div class="code panel pdl" style="border-width: 1px;"><div class="codeContent panelContent pdl">
<pre class="syntaxhighlighter-pre" data-syntaxhighlighter-params="brush: java; gutter: false; theme: Confluence" data-theme="Confluence">&quot;Name: &lt;Name&gt;&quot;
&quot;Status: &lt;Status&gt;&quot;
&quot;Arn: &lt;Arn&gt;&quot;
&quot;FailureReason: &lt;FailureReason&gt;&quot;
&quot;CreationTime: &lt;CreationTime&gt;&quot;
&quot;TrainingStartTime: &lt;TrainingStartTime&gt;&quot;
&quot;TrainingEndTime: &lt;TrainingEndTime&gt;&quot;
</pre>
</div></div></li></ol></li><li><p><strong>Confirm</strong> your changes.</p></li></ol></li><li><p>Leave everything else as default and click Next.</p></li><li><p>It is a good practice to add tags to your resources in AWS but skip this section for now. Click Next.</p></li><li><p>Review and Click <strong>Create rule</strong>.</p></li><li><p>You should see the rule you created listed under Rules</p><span class="confluence-embedded-file-wrapper image-center-wrapper confluence-embedded-manual-size"><img class="confluence-embedded-image image-center" width="625" loading="lazy" src="attachments/2324561934/2324135992.png?width=625" data-image-src="attachments/2324561934/2324135992.png" data-height="642" data-width="1703" data-unresolved-comment-count="0" data-linked-resource-id="2324135992" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-015121.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="3df31562-ec04-483d-9631-b576df21a09a" data-media-type="file"></span><p> </p></li></ol></li><li><p>Create Failure Rule in EventBridge</p><ol><li><p>Follow the instructions in Step 6 with the two changes below:</p><ol><li><p>Name the rule <strong>SageMakerFailureRule </strong>in step <strong>6c</strong></p></li><li><p>Use the following code in steps <strong>6h</strong> and <strong>6i</strong> when setting the <strong>Event Pattern </strong>for your second rule.</p><ol><li><div class="code panel pdl" style="border-width: 1px;"><div class="codeContent panelContent pdl">
<pre class="syntaxhighlighter-pre" data-syntaxhighlighter-params="brush: java; gutter: false; theme: Confluence" data-theme="Confluence">{
  &quot;source&quot;: [&quot;aws.sagemaker&quot;],
  &quot;detail-type&quot;: [&quot;SageMaker Processing Job State Change&quot;],
  &quot;detail&quot;: {
    &quot;ProcessingJobStatus&quot;: [&quot;Failed&quot;]
  }
}
</pre>
</div></div></li></ol></li></ol></li></ol></li></ol><p><strong>NOTE:</strong> The two rules you have created are only for your Training Job. You would need to create rules for your Processing and Transformation jobs as well to track their status. But this is example is sufficient for this exercise.</p><p><strong>NOTE: </strong>For the rest of this lab and the following labs, monitor your email address for notifications regarding your SageMaker Pipeline Training Job. You will be notified when the job completes or fails.</p><p><em>Part 2:</em></p><ol><li><p>Return to your SageMaker Notebook Instance</p><ol><li><p>Navigate to <strong>Amazon</strong> <strong>SageMaker</strong> using the search bar at the top.</p></li><li><p>Navigate to the created Notebook instance.</p><ol><li><p>Select <strong>Notebook</strong> &gt; <strong>Notebook instances </strong>from the left navigation bar.</p></li><li><p>Select <strong>Open JupyterLab </strong>from the <strong>aieu-notebook-instance</strong>.</p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324135998.png" data-image-src="attachments/2324561934/2324135998.png" data-height="663" data-width="1706" data-unresolved-comment-count="0" data-linked-resource-id="2324135998" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-015814.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="79c45968-6966-4a77-b442-f8cf9a1bae4d" data-media-type="file"></span></li></ol></li></ol></li><li><p>Set up your Notebook Instance repository for Lab 2</p><ol><li><p>Hit the <strong>+</strong> on the top left to open the Launcher Page</p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324136004.png" data-image-src="attachments/2324561934/2324136004.png" data-height="639" data-width="1699" data-unresolved-comment-count="0" data-linked-resource-id="2324136004" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-020544.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="14571165-392e-4669-bd26-ef81eb8cc275" data-media-type="file"></span></li><li><p>Scroll down and open a Terminal</p></li><li><p>Copy and paste the following code into your Terminal. Hit Enter.</p><div class="code panel pdl" style="border-width: 1px;"><div class="codeContent panelContent pdl">
<pre class="syntaxhighlighter-pre" data-syntaxhighlighter-params="brush: java; gutter: false; theme: Confluence" data-theme="Confluence">cd SageMaker/aws-intro-to-mlops/
git pull origin main
git fetch --all --tags
git checkout lab2
</pre>
</div></div></li><li><p>You are now set up for Lab 2</p></li></ol></li><li><p>Read through the Training step in pipeline.py</p><ol><li><p>Open <strong>pipeline.py</strong>. Notice the training step that has been added in Lines 180-230.</p><ol><li><p>Line 188 specifies the AWS built-in algorithm</p></li><li><p>Hyperparameters are set in Lines 205-213</p></li><li><p>point to the S3 bucket with our preprocessed data (219-232).</p></li><li><p>The Amazon SageMaker XGBoost algorithm is being used to build our regression model.</p></li></ol></li></ol></li><li><p>Run the pipeline</p><ol><li><p>Open <strong>pipeline.py </strong>again by double-clicking.</p></li><li><p>Hover over any text in the script and right-click. Choose <strong>create console for editor</strong>. Select <strong>conda_python_3 </strong>as your preferred terminal when prompted.<strong> </strong>The console will open in the bottom bar</p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324136010.png" data-image-src="attachments/2324561934/2324136010.png" data-height="697" data-width="1710" data-unresolved-comment-count="0" data-linked-resource-id="2324136010" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220609-212724.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="e9d4f398-b9bb-4a1a-9877-05165232d89b" data-media-type="file"></span></li><li><p>In the new console, type <strong>run pipeline.py</strong> and hit shift-enter.</p><ol><li><p>The pipeline may run for up to 15 minutes so this would be a great time to grab a cup of coffee or tea. The finished pipeline will return the message: “<code>Wine Model Build Pipeline complete.</code>&quot;</p></li><li><p>Continue to the next step to visualize your pipeline as it executes.</p></li></ol></li></ol></li><li><p>View Pipeline Graph</p><ol><li><p>Navigate to <strong>SageMaker Studio</strong></p><ol><li><p>Return to the Amazon SageMaker home page. Click <strong>Studio</strong> on the left navigation bar and select<strong> aieu-student </strong>under users.</p></li><li><p>Select <strong>Studio </strong>under <strong>Launch App</strong>.</p></li></ol></li><li><p>View Pipeline Graph</p><ol><li><p>Select the SageMaker resources icon on the left console :pipeline: .</p></li><li><p>In the drop-down menu select <strong>Pipelines</strong>.</p></li><li><p>Select <strong>WineQualityPipeline </strong>from the list of pipelines.</p></li><li><p>If your pipeline is still executing, wait for it to complete, but you can still view the graph. Double-click on the run.</p><span class="confluence-embedded-file-wrapper image-center-wrapper confluence-embedded-manual-size"><img class="confluence-embedded-image image-center" width="612" loading="lazy" src="attachments/2324561934/2324136016.png?width=612" data-image-src="attachments/2324561934/2324136016.png" data-height="327" data-width="1703" data-unresolved-comment-count="0" data-linked-resource-id="2324136016" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-022149.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="7c5382a6-83f6-4cf8-9cc2-4c557240d90a" data-media-type="file"></span><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324136022.png" data-image-src="attachments/2324561934/2324136022.png" data-height="618" data-width="1462" data-unresolved-comment-count="0" data-linked-resource-id="2324136022" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-022627.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="26b699f2-35c4-4bd3-ab25-61dda9dcce90" data-media-type="file"></span></li><li><p>Notice the training step has been added to the graph. Select the training<strong> </strong>node. Note the name of this node - it will be a quiz question!</p></li></ol></li></ol></li><li><p>Check your email for a notification regarding your training pipeline.</p></li><li><p>Ensure you shut down any Terminal Sessions or Kernel Sessions in your Notebook Instance</p><span class="confluence-embedded-file-wrapper image-center-wrapper"><img class="confluence-embedded-image image-center" loading="lazy" src="attachments/2324561934/2324136028.png" data-image-src="attachments/2324561934/2324136028.png" data-height="416" data-width="415" data-unresolved-comment-count="0" data-linked-resource-id="2324136028" data-linked-resource-version="1" data-linked-resource-type="attachment" data-linked-resource-default-alias="image-20220610-020349.png" data-base-url="https://elderresearch.atlassian.net/wiki" data-linked-resource-content-type="image/png" data-linked-resource-container-id="2324561934" data-linked-resource-container-version="2" data-media-id="bc4e2046-af04-4b06-9784-487915048fad" data-media-type="file"></span></li></ol><p> </p><p> </p>
                    </div>

                                </div> 
            <div id="footer" role="contentinfo">
               
            </div>
        </div>     </body>
</html>
